module CobolSyntax where
 
data Cobword = Lex_id Lex_id
 
data Cobol_source_program = Cobol_source_program Identification
						 Program_id_cobol_source_program
						 Identification_division_content
						 (Maybe Environment_division) (Maybe Data_division)
						 (Maybe Procedure_division) (Maybe End_program)
 
data End_program = End_program Program_name
 
data Environment_division = Environment_division Environment_division_content
 
data Data_division = Data_division Data_division_content
 
data Identification = IDENTIFICATION
		    | ID
 
data Identification_division_content = Identification_division_content [Identification_division_phrase]
 
data Author = Author (Maybe ())
 
data Installation = Installation (Maybe ())
 
data Date_written = Date_written (Maybe ())
 
data Date_compiled = Date_compiled (Maybe ())
 
data Security = Security (Maybe ())
 
data Remarks = Remarks (Maybe ())
 
data Identification_division_phrase = Author1 Author
				    | Installation1 Installation
				    | Date_written1 Date_written
				    | Date_compiled1 Date_compiled
				    | Security1 Security
				    | Remarks1 Remarks
 
data Program_id_cobol_source_program = Program_id_cobol_source_program (Maybe
									  ())
								       Program_name
								       (Maybe Initial_program)
								       (Maybe ())
 
data Initial_program = Initial_program (Maybe ()) (Maybe ())
 
data Environment_division_content = Environment_division_content (Maybe
								    Configuration_section)
								 (Maybe Input_output_section)
 
data Input_output_section = Input_output_section (Maybe
						    File_control_paragraph)
						 (Maybe I_o_control_paragraph)
 
data File_control_paragraph = File_control_paragraph [File_control_entry]
 
data File_control_entry = File_control_entry Select_clause
					     Assign_clause [Fce_phrase]
 
data Organization_is = Organization_is (Maybe ())
 
data Alt_sequential_random_dynamic = SEQUENTIAL
				   | RANDOM
				   | DYNAMIC
 
data Select_clause = Select_clause (Maybe ()) File_name
 
data Assign_clause = Assign_clause (Maybe ())
				   [Alt_assignment_name_literal]
 
data Alt_assignment_name_literal = Assignment_name Assignment_name
				 | Literal Literal
 
data Reserve_clause = Reserve_clause Integer_number (Maybe Areas)
 
data Areas = AREA
	   | AREAS
 
data Padding_character_clause = Padding_character_clause (Maybe ())
							 (Maybe ()) Alt_qualified_data_name_literal
 
data Record_delimiter_clause = Record_delimiter_clause (Maybe ())
						       Record_delimiter_name
 
data Record_delimiter_name = STANDARD_1
			   | Assignment_name1 Assignment_name
 
data Password_clause = Password_clause (Maybe ()) Data_name
 
data File_status_clause = File_status_clause (Maybe ()) (Maybe ())
					     Qualified_data_name (Maybe Qualified_data_name)
 
data Relative_key_clause = Relative_key_clause (Maybe ())
					       (Maybe ()) Qualified_data_name
 
data Record_key_clause = Record_key_clause (Maybe ()) (Maybe ())
					   Qualified_data_name
 
data Alternate_record_key_clause = Alternate_record_key_clause (Maybe
								  ())
							       (Maybe ()) (Maybe ())
							       Qualified_data_name
							       (Maybe Password_clause)
							       (Maybe With_duplicates)
 
data With_duplicates = With_duplicates (Maybe ())
 
data I_o_control_paragraph = I_o_control_paragraph (Maybe I_o_sam)
						   (Maybe I_o_sort_merge)
 
data I_o_sam = I_o_sam [Qsam_or_sam_or_vsam_i_o_control_entries]
 
data I_o_sort_merge = I_o_sort_merge Sort_merge_i_o_control_entries
 
data Qsam_or_sam_or_vsam_i_o_control_entries = Qsam_or_sam_or_vsam_i_o_control_entries_1 Qsam_or_sam_or_vsam_i_o_control_entries_1
					     | Qsam_or_sam_or_vsam_i_o_control_entries_2 Qsam_or_sam_or_vsam_i_o_control_entries_2
					     | Qsam_or_sam_or_vsam_i_o_control_entries_3 Qsam_or_sam_or_vsam_i_o_control_entries_3
					     | Qsam_or_sam_or_vsam_i_o_control_entries_4 Qsam_or_sam_or_vsam_i_o_control_entries_4
 
data Qsam_or_sam_or_vsam_i_o_control_entries_1 = Qsam_or_sam_or_vsam_i_o_control_entries_11 Alt_assignment_name_file_name
											    (Maybe
											       ())
											    Every_phrase
											    (Maybe
											       ())
											    File_name
 
data Every_phrase_1 = Every_phrase_1 Integer_number
 
data Every_phrase_2 = Every_phrase_2 (Maybe ()) Alt_reel_unit
 
data Every_phrase = Every_phrase_11 Every_phrase_1
		  | Every_phrase_21 Every_phrase_2
 
data Alt_assignment_name_file_name = Assignment_name2 Assignment_name
				   | File_name File_name
 
data Qsam_or_sam_or_vsam_i_o_control_entries_2 = Qsam_or_sam_or_vsam_i_o_control_entries_21 (Maybe
											       ())
											    (Maybe
											       ())
											    (Maybe
											       ())
											    File_name
											    [File_name]
 
data Qsam_or_sam_or_vsam_i_o_control_entries_3 = Qsam_or_sam_or_vsam_i_o_control_entries_31 (Maybe
											       ())
											    (Maybe
											       ())
											    [File_name_position]
 
data Position = Position Integer_number
 
data File_name_position = File_name_position File_name
					     (Maybe Position)
 
data Qsam_or_sam_or_vsam_i_o_control_entries_4 = Qsam_or_sam_or_vsam_i_o_control_entries_41 (Maybe
											       ())
											    [File_name]
 
data Sort_merge_i_o_control_entries = Sort_merge_i_o_control_entries (Maybe
									Rerun_on)
								     [Same_area]
 
data Rerun_on = Rerun_on Assignment_name
 
data Record_sort = RECORD
		 | SORT
		 | SORT_MERGE
 
data Same_area = Same_area Record_sort (Maybe ()) (Maybe ())
			   File_name [File_name]
 
data Configuration_section = Configuration_section Configuration_section_paragraphs
 
data Configuration_section_paragraphs = Configuration_section_paragraphs [Configuration_section_paragraph]
 
data Configuration_section_paragraph = Source_computer_paragraph Source_computer_paragraph
				     | Object_computer_paragraph Object_computer_paragraph
				     | Special_names_paragraph Special_names_paragraph
 
data Source_computer_paragraph = Source_computer_paragraph1 (Maybe
							       Source_computer_name)
 
data With_debugging_mode = With_debugging_mode (Maybe ())
 
data Source_computer_name = Source_computer_name Computer_name
						 (Maybe With_debugging_mode)
 
data Object_computer_paragraph = Object_computer_paragraph1 (Maybe
							       Object_computer_name)
 
data Memory_size_type = WORDS
		      | CHARACTERS
		      | MODULES
 
data Memory_size = Memory_size (Maybe ()) Integer_number
			       Memory_size_type
 
data Object_computer_name = Object_computer_name Computer_name
						 (Maybe Memory_size)
						 Object_computer_paragraph_sequence_phrase
 
data Object_computer_paragraph_sequence_phrase = Object_computer_paragraph_sequence_phrase (Maybe
											      Program_collating_sequence)
											   (Maybe
											      Segment_limit)
 
data Program_collating_sequence = Program_collating_sequence (Maybe
								())
							     (Maybe ()) (Maybe ()) Alphabet_name
 
data Segment_limit = Segment_limit (Maybe ()) Priority_number
 
data Special_names_paragraph = Special_names_paragraph1 [Special_names_paragraph_phrase]
							Special_names_paragraph_clauses (Maybe ())
 
data Is_mnemonic_name = Is_mnemonic_name (Maybe ()) Mnemonic_name
					 (Maybe Special_names_paragraph_status_phrase)
 
data Special_names_paragraph_phrase_tail = Is_mnemonic_name1 Is_mnemonic_name
					 | Special_names_paragraph_status_phrase Special_names_paragraph_status_phrase
 
data Special_names_paragraph_phrase = Special_names_paragraph_phrase Environment_name
								     Special_names_paragraph_phrase_tail
 
data Special_names_paragraph_status_phrase = Special_names_paragraph_status_phrase_1 Special_names_paragraph_status_phrase_1
					   | Special_names_paragraph_status_phrase_2 Special_names_paragraph_status_phrase_2
 
data Special_names_paragraph_status_phrase_1 = Special_names_paragraph_status_phrase_11 (Maybe
											   ())
											(Maybe ())
											Condition
											(Maybe
											   Off_status)
 
data Off_status = Off_status (Maybe ()) (Maybe ()) Condition
 
data Special_names_paragraph_status_phrase_2 = Special_names_paragraph_status_phrase_21 (Maybe
											   ())
											(Maybe ())
											Condition
											(Maybe
											   On_status)
 
data On_status = On_status (Maybe ()) (Maybe ()) Condition
 
data Special_names_paragraph_clauses = Special_names_paragraph_clauses [Special_names_paragraph_clause]
 
data Special_names_paragraph_clause = Alphabet_clause Alphabet_clause
				    | Symbolic_characters_clause Symbolic_characters_clause
				    | Class_clause Class_clause
				    | Currency_sign_clause Currency_sign_clause
				    | Decimal_point_clause Decimal_point_clause
 
data Alphabet_clause = Alphabet_clause1 Alphabet_name (Maybe ())
					Alphabet_type
 
data Alphabet_type_also = Alphabet_type_also Literal
 
data Alphabet_type_alsos = Alphabet_type_alsos [Alphabet_type_also]
 
data Alphabet_type_also_through = Through_literal Through_literal
				| Alphabet_type_alsos1 Alphabet_type_alsos
 
data Alphabet_type_other = Alphabet_type_other Literal
					       (Maybe Alphabet_type_also_through)
 
data Alphabet_type_others = Alphabet_type_others [Alphabet_type_other]
 
data Alphabet_type = STANDARD_11
		   | STANDARD_2
		   | NATIVE
		   | EBCDIC
		   | Alphabet_type_others1 Alphabet_type_others
 
data Symbolic_characters_clause = Symbolic_characters_clause1 (Maybe
								 ())
							      [Symbolic_character_mapping]
							      (Maybe In_alphabet_name)
 
data Are = ARE
	 | IS
 
data Symbolic_character_mapping = Symbolic_character_mapping [Symbolic_character]
							     (Maybe Are) [Integer_number]
 
data In_alphabet_name = In_alphabet_name Alphabet_name
 
data Class_clause = Class_clause1 Class_name (Maybe ())
				  [Literal_through_literal]
 
data Currency_sign_clause = Currency_sign_clause1 (Maybe ())
						  (Maybe ()) Literal
 
data Decimal_point_clause = Decimal_point_clause1 (Maybe ())
 
data Data_division_content = Data_division_content (Maybe
						      File_section)
						   (Maybe Working_storage_section)
						   (Maybe Linkage_section)
 
data File_section_entry = File_section_entry File_and_sort_description_entry
					     [Data_description_entry]
 
data File_section = File_section [File_section_entry]
 
data Working_storage_section = Working_storage_section [Data_description_entry]
 
data Linkage_section = Linkage_section [Data_description_entry]
 
data File_and_sort_description_entry = File_and_sort_description_entry Alt_fd_sd
								       File_name
								       File_and_sort_description_entry_clauses
 
data Alt_fd_sd = FD
	       | SD
 
data File_and_sort_description_entry_clauses = File_and_sort_description_entry_clauses [File_and_sort_description_entry_clause]
 
data File_and_sort_description_entry_clause = External_clause External_clause
					    | Global_clause Global_clause
					    | Block_contains_clause Block_contains_clause
					    | Record_clause Record_clause
					    | Label_records_clause Label_records_clause
					    | Value_of_clause Value_of_clause
					    | Data_records_clause Data_records_clause
					    | Linage_clause Linage_clause
					    | Recording_mode_clause Recording_mode_clause
					    | Code_set_clause Code_set_clause
 
data Block_contains_clause = Block_contains_clause1 (Maybe ())
						    (Maybe Integer_to) Integer_number
						    (Maybe Alt_characters_records)
 
data Alt_characters_records = CHARACTERS1
			    | RECORDS
			    | RECORD1
 
data Record_clause = Record_clause1 Record_clause_tail
 
data Depending_on = Depending_on (Maybe ()) Data_name
 
data Record_clause_tail_1 = Record_clause_tail_1 (Maybe ())
						 Integer_number (Maybe ())
 
data Record_clause_tail_2 = Record_clause_tail_2 (Maybe ())
						 Integer_number Integer_number (Maybe ())
 
data Record_clause_tail_3 = Record_clause_tail_3 Record_varying_phrase
						 (Maybe Depending_on)
 
data Record_clause_tail = Record_clause_tail_21 Record_clause_tail_2
			| Record_clause_tail_11 Record_clause_tail_1
			| Record_clause_tail_31 Record_clause_tail_3
 
data Record_varying_phrase = Record_varying_phrase (Maybe ())
						   (Maybe ()) (Maybe ()) (Maybe From_integer)
						   (Maybe To_integer) (Maybe ())
 
data From_integer = From_integer (Maybe ()) Integer_number
 
data To_integer = To_integer Integer_number
 
data Label_records_clause = Label_records_clause1 Records_are
						  Label_records_clause_tail
 
data Data_names = Data_names [Data_name]
 
data Label_records_clause_tail = STANDARD
			       | OMITTED
			       | Data_names1 Data_names
 
data Value_of_clause = Value_of_clause1 [Value_of_clause_tail]
 
data Alt_qualified_data_name_literal = Qualified_data_name Qualified_data_name
				     | Literal1 Literal
 
data Value_of_clause_tail = Value_of_clause_tail System_name
						 (Maybe ()) Alt_qualified_data_name_literal
 
data Data_records_clause = Data_records_clause1 Records_are
						[Data_name]
 
data Records_are = Records_are Records (Maybe Are)
 
data Linage_clause = Linage_clause1 (Maybe ())
				    Alt_data_name_integer (Maybe ()) Linage_footing_phrase
 
data Linage_footing_phrase = Linage_footing_phrase (Maybe Footing)
						   (Maybe Lines_top) (Maybe Lines_bottom)
 
data Alt_data_name_integer = Data_name Data_name
			   | Integer Integer_number
 
data Footing = Footing (Maybe ()) (Maybe ()) Alt_data_name_integer
 
data Lines_top = Lines_top (Maybe ()) (Maybe ())
			   Alt_data_name_integer
 
data Lines_bottom = Lines_bottom (Maybe ()) (Maybe ())
				 Alt_data_name_integer
 
data Recording_mode_clause = Recording_mode_clause1 (Maybe ())
						    (Maybe ()) Cobword
 
data Code_set_clause = Code_set_clause1 (Maybe ()) Alphabet_name
 
data Data_description_entry = Data_description_entry_1 Data_description_entry_1
			    | Copy_statement Copy_statement
 
data Data_description_entry_1 = Data_description_entry_11 Level_number
							  (Maybe Alt_data_name_filler)
							  Data_description_entry_clauses (Maybe ())
 
data Alt_data_name_filler = Data_name1 Data_name
			  | FILLER
 
data Data_description_entry_clauses = Data_description_entry_clauses [Data_description_entry_clause]
 
data Data_description_entry_clause = Redefines_clause Redefines_clause
				   | Blank_when_zero_clause Blank_when_zero_clause
				   | External_clause1 External_clause
				   | Global_clause1 Global_clause
				   | Justified_clause Justified_clause
				   | Occurs_clause Occurs_clause
				   | Picture_clause Picture_clause
				   | Sign_clause Sign_clause
				   | Synchronized_clause Synchronized_clause
				   | Usage_clause Usage_clause
				   | Renames_clause Renames_clause
				   | Condition_value_clause Condition_value_clause
 
data Redefines_clause = Redefines_clause1 Data_name
 
data Blank_when_zero_clause = Blank_when_zero_clause1 (Maybe ())
						      Zeroes
 
data Zeroes = ZERO
	    | ZEROS
	    | ZEROES
 
data External_clause = External_clause2 (Maybe ())
 
data Global_clause = Global_clause2 (Maybe ())
 
data Justified_clause = Justified_clause1 Justified (Maybe ())
 
data Justified = JUSTIFIED
	       | JUST
 
data Occurs_clause = Occurs_clause_2 Occurs_clause_2
		   | Occurs_clause_1 Occurs_clause_1
 
data Occurs_clause_1 = Occurs_clause_11 Integer_number (Maybe ())
					[Occurs_clause_key] (Maybe Indexed_by)
 
data Occurs_clause_2 = Occurs_clause_21 (Maybe Integer_to)
					Integer_number (Maybe ()) (Maybe ()) Qualified_data_name
					[Occurs_clause_key] (Maybe Indexed_by)
 
data Integer_to = Integer_to Integer_number
 
data Occurs_clause_key = Occurs_clause_key Alt_ascending_descending
					   (Maybe ()) (Maybe ()) [Qualified_data_name]
 
data Indexed_by = Indexed_by (Maybe ()) [Index_name]
 
data Picture_clause = Picture_clause1 Picture (Maybe ())
				      Picture_string
 
data Picture = PICTURE
	     | PIC
 
data Sign_clause = Sign_clause1 (Maybe Sign_is)
				Alt_leading_trailing (Maybe Separate_character)
 
data Sign_is = Sign_is (Maybe ())
 
data Separate_character = Separate_character (Maybe ())
 
data Alt_leading_trailing = LEADING
			  | TRAILING
 
data Synchronized_clause = Synchronized_clause1 Synchronized
						(Maybe Alt_left_right)
 
data Alt_left_right = LEFT
		    | RIGHT
 
data Synchronized = SYNCHRONIZED
		  | SYNC
 
data Usage_clause = Usage_clause1 (Maybe Usage_is) Usage
 
data Usage_is = Usage_is (Maybe ())
 
data Usage = BINARY
	   | COMP
	   | COMP_1
	   | COMP_2
	   | COMP_3
	   | COMP_4
	   | COMPUTATIONAL
	   | COMPUTATIONAL_1
	   | COMPUTATIONAL_2
	   | COMPUTATIONAL_3
	   | COMPUTATIONAL_4
	   | DISPLAY
	   | DISPLAY_1
	   | INDEX
	   | PACKED_DECIMAL
	   | POINTER
 
data Renames_clause = Renames_clause1 Qualified_data_name
				      (Maybe Through_qualified_data_name)
 
data Through_qualified_data_name = Through_qualified_data_name Through
							       Qualified_data_name
 
data Condition_value_clause = Condition_value_clause1 Values_are
						      [Literal_through_literal]
 
data Through_literal = Through_literal1 Through Literal
 
data Literal_through_literal = Literal_through_literal Literal
						       (Maybe Through_literal)
 
data Values_are = Values_are Values (Maybe Are)
 
data Procedure_division = Procedure_division Using_phrase
					     (Maybe Declaratives) Sections
 
data Declaratives_content = Declaratives_content Section_header
						 Use_statement Paragraphs
 
data Declaratives = Declaratives [Declaratives_content]
 
data Using_phrase = Using_phrase_1 Using_phrase_1
		  | Using_phrase_2 Using_phrase_2
 
data Using_phrase_1 = Using_phrase_11 (Maybe
					 Using_data_name_pluslist)
 
data Using_phrase_2 = Using_phrase_21 (Maybe Using_data_names)
				      Copy_statement
 
data Using_data_names = Using_data_names [Data_name]
 
data Section_header = Section_header Section_name
				     (Maybe Priority_number)
 
data Paragraphs = Paragraphs [Sentence] [Paragraph]
 
data Sentence = Sentence_1 Sentence_1
	      | Sentence_2 Sentence_2
 
data Sentence_1 = Sentence_11 Statement_list [()]
 
data Sentence_2 = Sentence_21 (Maybe Statement_list) Copy_statement
 
data Paragraph = Altered_goto Altered_goto
	       | Paragraph_1 Paragraph_1
 
data Paragraph_1 = Paragraph_11 Paragraph_name [Sentence]
 
data Altered_goto = Altered_goto1 Paragraph_name (Maybe ())
 
data Sections = Sections Paragraphs [Section_with_header]
 
data Section_with_header = Section_with_header Section_header
					       Paragraphs
 
data Statement = Primitive Primitive
	       | Branch Branch
	       | Terminator Terminator
 
data Accept_statement = Accept_statement_2 Accept_statement_2
		      | Accept_statement_1 Accept_statement_1
 
data Accept_statement_1 = Accept_statement_11 Identifier
					      (Maybe From_environment_name)
 
data From_environment_name = From_environment_name Cobword
 
data Accept_statement_2 = Accept_statement_21 Identifier Date
 
data Date = DATE
	  | DAY
	  | DAY_OF_WEEK
	  | TIME
 
data Add_statement = Add_statement_2 Add_statement_2
		   | Add_statement_1 Add_statement_1
		   | Add_statement_3 Add_statement_3
 
data Add_statement_1 = Add_statement_11 [Cobword_lit]
					[Cobword_rounded]
 
data Add_statement_2 = Add_statement_21 [Cobword_lit]
					(Maybe To_cobword_lit) [Cobword_rounded]
 
data Add_statement_3 = Add_statement_31 Corresponding Identifier
					Identifier (Maybe ())
 
data Statement_list = Statement_list [Statement]
 
data Alter_statement = Alter_statement [Procedure_to_procedure]
 
data Proceed_to = Proceed_to
 
data Procedure_to_procedure = Procedure_to_procedure Procedure_name
						     (Maybe Proceed_to) Procedure_name
 
data Call_statement = Call_statement Cobword_lit
				     (Maybe Using_parameters)
 
data By_reference = By_reference (Maybe ())
 
data Content_parameter_value = Identifier Identifier
			     | Literal2 Literal
 
data Reference_parameter = Reference_parameter (Maybe By_reference)
					       Identifier
 
data Content_parameter = Content_parameter (Maybe ())
					   [Content_parameter_value]
 
data Parameter = Reference_parameter1 Reference_parameter
	       | Content_parameter1 Content_parameter
 
data Using_parameters = Using_parameters [Parameter]
 
data Cancel_statement = Cancel_statement [Cobword_lit]
 
data Close_statement = Close_statement [Close_statement_file_name]
 
data Alt_removal_no_rewind = For_removal For_removal
			   | With_no_rewind With_no_rewind
 
data Alt_reel_unit = REEL
		   | UNIT
 
data Alt_no_rewind_lock = No_rewind No_rewind
			| LOCK
 
data Close_statement_options_1 = Close_statement_options_1 Alt_reel_unit
							   (Maybe Alt_removal_no_rewind)
 
data Close_statement_options_2 = Close_statement_options_2 (Maybe
							      ())
							   Alt_no_rewind_lock
 
data Close_statement_options = Close_statement_options_11 Close_statement_options_1
			     | Close_statement_options_21 Close_statement_options_2
 
data Close_statement_file_name = Close_statement_file_name File_name
							   (Maybe Close_statement_options)
 
data Compute_statement = Compute_statement [Cobword_rounded] Equal
					   Arithmetic_expression
 
data Equal = Equal_dunno_a_0
	   | EQUAL
 
data Continue_statement = Continue_statement
 
data Delete_statement = Delete_statement File_name (Maybe ())
 
data Display_statement = Display_statement [Cobword_lit]
					   (Maybe Upon_environment_name) (Maybe With_no_advancing)
 
data Upon_environment_name = Upon_environment_name Cobword
 
data With_no_advancing = With_no_advancing (Maybe ())
 
data Divide_statement = Divide_statement_4 Divide_statement_4
		      | Divide_statement_5 Divide_statement_5
		      | Divide_statement_2 Divide_statement_2
		      | Divide_statement_3 Divide_statement_3
		      | Divide_statement_1 Divide_statement_1
 
data Divide_statement_1 = Divide_statement_11 Cobword_lit
					      [Cobword_rounded]
 
data Divide_statement_2 = Divide_statement_21 Cobword_lit
					      Cobword_lit [Cobword_rounded]
 
data Divide_statement_3 = Divide_statement_31 Cobword_lit
					      Cobword_lit [Cobword_rounded]
 
data Divide_statement_4 = Divide_statement_41 Cobword_lit
					      Cobword_lit Identifier (Maybe ()) Identifier
 
data Divide_statement_5 = Divide_statement_51 Cobword_lit
					      Cobword_lit Identifier (Maybe ()) Identifier
 
data Entry_statement = Entry_statement Literal
				       (Maybe Using_data_name_pluslist)
 
data Using_data_name_pluslist = Using_data_name_pluslist [Data_name]
 
data Evaluate_statement = Evaluate_statement Evaluate_condition
					     [Also_phrase]
 
data Evaluate_condition = Condition Condition
			| TRUE
			| FALSE
 
data Also_phrase = Also_phrase Evaluate_condition
 
data When_phrase_also_phrase = When_phrase_also_phrase Evaluate_phrase
 
data Evaluate_phrase = ANY
		     | Condition1 Condition
		     | TRUE1
		     | FALSE1
		     | Evaluate_phrase_1 Evaluate_phrase_1
 
data Evaluate_phrase_1 = Evaluate_phrase_11 (Maybe ())
					    Arithmetic_expression
					    (Maybe Through_arithmetic_expression)
 
data Through_arithmetic_expression = Through_arithmetic_expression Through
								   Arithmetic_expression
 
data Exit_statement = Exit_statement
 
data Exit_program_statement = Exit_program_statement
 
data Goback_statement = Goback_statement
 
data Go_to_statement = Go_to_statement_2 Go_to_statement_2
		     | Go_to_statement_1 Go_to_statement_1
		     | Go_to_statement_3 Go_to_statement_3
 
data Go_to_statement_1 = Go_to_statement_11 (Maybe ())
					    Procedure_name
 
data Go_to_statement_2 = Go_to_statement_21 (Maybe ())
					    [Procedure_name] (Maybe ()) Identifier
 
data If_statement = If_statement Condition (Maybe ())
 
data Initialize_statement = Initialize_statement [Identifier]
						 (Maybe Initialize_replacing_phrase)
 
data Initialize_replacing_type = ALPHABETIC
			       | ALPHANUMERIC
			       | NUMERIC
			       | ALPHANUMERIC_EDITED
			       | NUMERIC_EDITED
			       | DBCS
			       | EGCS
 
data Initialize_replacing_argument = Initialize_replacing_argument Initialize_replacing_type
								   (Maybe ()) Cobword_lit
 
data Initialize_replacing_phrase = Initialize_replacing_phrase [Initialize_replacing_argument]
 
data Inspect_statement = Inspect_statement_1 Inspect_statement_1
		       | Inspect_statement_2 Inspect_statement_2
		       | Inspect_statement_3 Inspect_statement_3
		       | Inspect_statement_4 Inspect_statement_4
 
data Inspect_statement_1 = Inspect_statement_11 Identifier
						[Tallying_argument]
 
data Inspect_statement_2 = Inspect_statement_21 Identifier
						Cobword_lit Cobword_lit [Before_after_phrase]
 
data Inspect_statement_3 = Inspect_statement_31 Identifier
						[Tallying_argument] [Inspect_replacing_phrase]
 
data Tallying_for_cobword_lit = Tallying_for_cobword_lit Cobword_lit
							 [Before_after_phrase]
 
data Alt_all_leading = ALL
		     | LEADING1
 
data Tallying_for_argument_1 = Tallying_for_argument_1 [Before_after_phrase]
 
data Tallying_for_argument_2 = Tallying_for_argument_2 Alt_all_leading
						       [Tallying_for_cobword_lit]
 
data Tallying_for_argument = Tallying_for_argument_11 Tallying_for_argument_1
			   | Tallying_for_argument_21 Tallying_for_argument_2
 
data Tallying_argument = Tallying_argument Identifier
					   [Tallying_for_argument]
 
data Inspect_statement_4 = Inspect_statement_41 Identifier
						[Inspect_replacing_phrase]
 
data Inspect_replacing_argument = Inspect_replacing_argument Inspect_by_argument
							     Inspect_by_argument
							     [Before_after_phrase]
 
data Alt_all_leading_first = ALL1
			   | LEADING2
			   | FIRST
 
data Inspect_replacing_phrase_1 = Inspect_replacing_phrase_1 Cobword_lit
							     [Before_after_phrase]
 
data Inspect_replacing_phrase_2 = Inspect_replacing_phrase_2 Alt_all_leading_first
							     [Inspect_replacing_argument]
 
data Inspect_replacing_phrase = Inspect_replacing_phrase_11 Inspect_replacing_phrase_1
			      | Inspect_replacing_phrase_21 Inspect_replacing_phrase_2
 
data Before_after_phrase = Before_after_phrase Alt_before_after
					       (Maybe ()) Cobword_lit
 
data Merge_statement = Merge_statement File_name [On_key_phrase]
				       (Maybe Collating_sequence) File_name [File_name]
				       Merge_statement_tail
 
data On_key_phrase = On_key_phrase (Maybe ())
				   Alt_ascending_descending (Maybe ()) [Qualified_data_name]
 
data Merge_statement_tail = Output_procedure Output_procedure
			  | Giving_file_names Giving_file_names
 
data Move_statement = Move_statement_1 Move_statement_1
		    | Move_statement_2 Move_statement_2
 
data Move_statement_1 = Move_statement_11 Cobword_lit [Identifier]
 
data Move_statement_2 = Move_statement_21 Corresponding Identifier
					  [Identifier]
 
data Multiply_statement = Multiply_statement_2 Multiply_statement_2
			| Multiply_statement_1 Multiply_statement_1
 
data Multiply_statement_1 = Multiply_statement_11 Cobword_lit
						  [Cobword_rounded]
 
data Multiply_statement_2 = Multiply_statement_21 Cobword_lit
						  Cobword_lit [Cobword_rounded]
 
data Open_statement = Open_statement [Open_statement_phrase]
 
data Alt_reversed_with_no_rewind = REVERSED
				 | With_no_rewind1 With_no_rewind
 
data Open_statement_input_file_name = Open_statement_input_file_name File_name
								     (Maybe
									Alt_reversed_with_no_rewind)
 
data With_no_rewind = With_no_rewind2 (Maybe ())
 
data Open_statement_output_file_name = Open_statement_output_file_name File_name
								       (Maybe With_no_rewind)
 
data Open_statement_input = Open_statement_input [Open_statement_input_file_name]
 
data Open_statement_output = Open_statement_output [Open_statement_output_file_name]
 
data Open_statement_i_o = Open_statement_i_o [File_name]
 
data Open_statement_extend = Open_statement_extend [File_name]
 
data Open_statement_phrase = Open_statement_input1 Open_statement_input
			   | Open_statement_output1 Open_statement_output
			   | Open_statement_i_o1 Open_statement_i_o
			   | Open_statement_extend1 Open_statement_extend
 
data Perform_statement = Perform_statement (Maybe
					      Perform_statement_procedure)
					   (Maybe Perform_varying_phrase) [Perform_after_phrase]
					   (Maybe Number_times) (Maybe Perform_until_phrase)
 
data Perform_statement_procedure = Perform_statement_procedure Procedure_name
							       (Maybe Through_procedure_name)
 
data Perform_varying_phrase = Perform_varying_phrase (Maybe
							With_test)
						     Identifier Cobword_lit Cobword_lit Condition
 
data Perform_after_phrase = Perform_after_phrase Identifier
						 Cobword_lit Cobword_lit Condition
 
data Perform_until_phrase = Perform_until_phrase (Maybe With_test)
						 Condition
 
data With_test = With_test (Maybe ()) Alt_before_after
 
data Read_statement = Read_statement File_name (Maybe ())
				     (Maybe ()) (Maybe Into_identifier)
				     (Maybe Key_is_qualified_data_name)
 
data Key_is_qualified_data_name = Key_is_qualified_data_name (Maybe
								())
							     Qualified_data_name
 
data Release_statement = Release_statement Record_name
					   (Maybe From_identifier)
 
data Return_statement = Return_statement File_name (Maybe ())
					 (Maybe Into_identifier)
 
data Into_identifier = Into_identifier Identifier
 
data Rewrite_statement = Rewrite_statement Record_name
					   (Maybe From_identifier)
 
data Search_statement = Search_statement_1 Search_statement_1
		      | Search_statement_2 Search_statement_2
 
data Search_statement_1 = Search_statement_11 Identifier
					      (Maybe Varying_identifier)
 
data Varying_identifier = Varying_identifier Identifier
 
data Search_statement_2 = Search_statement_21 Identifier
 
data Equal_to = Equal_to_1 Equal_to_1
	      | Equal_to_dunno_b_0
 
data Set_statement = Set_statement [Set_statement_phrase]
 
data Alt_up_down_by = Alt_up_down_by Alt_up_down
 
data Sort_statement = Sort_statement File_name [On_key_is_phrase]
				     (Maybe With_duplicates_in_order) (Maybe Collating_sequence)
				     Sort_statement_in Sort_statement_out
 
data Key_is = Key_is (Maybe ())
 
data Alt_ascending_descending = ASCENDING
			      | DESCENDING
 
data On_key_is_phrase = On_key_is_phrase (Maybe ())
					 Alt_ascending_descending (Maybe Key_is)
					 [Qualified_data_name]
 
data With_duplicates_in_order = With_duplicates_in_order (Maybe ())
							 (Maybe ()) (Maybe ())
 
data Collating_sequence = Collating_sequence (Maybe ()) (Maybe ())
					     Alphabet_name
 
data Through = THROUGH
	     | THRU
 
data Through_procedure_name = Through_procedure_name Through
						     Procedure_name
 
data Using_file_names = Using_file_names [File_name]
 
data Input_procedure = Input_procedure (Maybe ()) Procedure_name
				       (Maybe Through_procedure_name)
 
data Giving_file_names = Giving_file_names1 [File_name]
 
data Output_procedure = Output_procedure1 (Maybe ()) Procedure_name
					  (Maybe Through_procedure_name)
 
data Sort_statement_in = Using_file_names1 Using_file_names
		       | Input_procedure1 Input_procedure
 
data Sort_statement_out = Giving_file_names2 Giving_file_names
			| Output_procedure2 Output_procedure
 
data Start_statement = Start_statement File_name
				       (Maybe Key_is_rel_op_qualified_data_name)
 
data Rel_op = Equal_to Equal_to
	    | Greater_than Greater_than
	    | Greater_than_or_equal_to Greater_than_or_equal_to
 
data Key_is_rel_op_qualified_data_name = Key_is_rel_op_qualified_data_name (Maybe
									      ())
									   Rel_op
									   Qualified_data_name
 
data Stop_statement = Stop_statement Alt_run_literal
 
data Alt_run_literal = RUN
		     | Literal3 Literal
 
data String_statement = String_statement [Delimited_by_phrase]
					 Identifier (Maybe With_pointer_identifier)
 
data Cobword_lit_size = Literal4 Literal
		      | Identifier1 Identifier
		      | SIZE
 
data Delimited_by_phrase = Delimited_by_phrase [Cobword_lit]
					       (Maybe ()) Cobword_lit_size
 
data Subtract_statement = Subtract_statement_2 Subtract_statement_2
			| Subtract_statement_1 Subtract_statement_1
			| Subtract_statement_3 Subtract_statement_3
 
data Subtract_statement_1 = Subtract_statement_11 [Cobword_lit]
						  [Cobword_rounded]
 
data Subtract_statement_2 = Subtract_statement_21 [Cobword_lit]
						  Cobword_lit [Cobword_rounded]
 
data Cobword_rounded = Cobword_rounded Identifier (Maybe ())
 
data Subtract_statement_3 = Subtract_statement_31 Corresponding
						  Identifier Identifier (Maybe ())
 
data Corresponding = CORRESPONDING
		   | CORR
 
data Unstring_statement = Unstring_statement Identifier
					     (Maybe Delimited_by_all_phrase)
					     [Unstring_statement_dst]
					     (Maybe With_pointer_identifier)
					     (Maybe Tallying_in_identifier)
 
data Cobword_lit = Literal5 Literal
		 | Identifier2 Identifier
 
data Or_all_cobword_lit = Or_all_cobword_lit (Maybe ()) Cobword_lit
 
data Delimited_by_all_phrase = Delimited_by_all_phrase (Maybe ())
						       (Maybe ()) Cobword_lit [Or_all_cobword_lit]
 
data Delimiter_in_identifier = Delimiter_in_identifier (Maybe ())
						       Identifier
 
data Count_in_identifier = Count_in_identifier (Maybe ())
					       Identifier
 
data Unstring_statement_dst = Unstring_statement_dst Identifier
						     (Maybe Delimiter_in_identifier)
						     (Maybe Count_in_identifier)
 
data With_pointer_identifier = With_pointer_identifier (Maybe ())
						       Identifier
 
data Tallying_in_identifier = Tallying_in_identifier (Maybe ())
						     Identifier
 
data Write_statement = Write_statement Record_name
				       (Maybe From_identifier) (Maybe Advancing_phrase)
 
data Lines = LINE
	   | LINES
 
data Cobword_int = Identifier3 Identifier
		 | Integer1 Integer_number
 
data Nr_lines_phrase = Nr_lines_phrase Cobword_int (Maybe Lines)
 
data Page_phrase = Nr_lines_phrase1 Nr_lines_phrase
		 | PAGE
 
data Alt_before_after = BEFORE
		      | AFTER
 
data Advancing_phrase = Advancing_phrase Alt_before_after
					 (Maybe ()) Page_phrase
 
data From_identifier = From_identifier Identifier
 
data End_of_page = END_OF_PAGE
		 | EOP
 
data Copy_statement = Copy_statement1 Alt_text_name_literal
				      (Maybe In_library) (Maybe ())
				      (Maybe Copy_statement_replacing_phrase)
 
data Alt_of_in = OF
	       | IN
 
data Alt_library_name_literal = Library_name Library_name
			      | Literal6 Literal
 
data In_library = In_library Alt_of_in Alt_library_name_literal
 
data Copy_statement_by_phrase = Copy_statement_by_phrase Copy_operand
							 Copy_operand
 
data Copy_statement_replacing_phrase = Copy_statement_replacing_phrase [Copy_statement_by_phrase]
 
data Alt_text_name_literal = Text_name Text_name
			   | Literal7 Literal
 
data Copy_operand = Quoted_pseudo_text Quoted_pseudo_text
		  | Identifier4 Identifier
		  | Literal8 Literal
 
data Use_statement = Use_statement_1 Use_statement_1
		   | Use_statement_2 Use_statement_2
		   | Use_statement_3 Use_statement_3
 
data Use_statement_1 = Use_statement_11 (Maybe ()) (Maybe ())
					Alt_exception_error (Maybe ()) Alt_file_names_i_o
 
data Alt_exception_error = EXCEPTION
			 | ERROR
 
data Use_statement_2 = Use_statement_21 (Maybe ()) (Maybe ())
					(Maybe Alt_beginning_ending) (Maybe Alt_file_reel_unit)
					(Maybe ()) Alt_file_names_i_o
 
data Alt_beginning_ending = BEGINNING
			  | ENDING
 
data Alt_file_reel_unit = FILE
			| REEL1
			| UNIT1
 
data File_names = File_names [File_name]
 
data Alt_file_names_i_o = File_names1 File_names
			| INPUT
			| OUTPUT
			| I_O
			| EXTEND
 
data Use_statement_3 = Use_statement_31 (Maybe ()) (Maybe ())
					Alt_procedures_all_procedures
 
data Procedure_names = Procedure_names [Procedure_name]
 
data Alt_procedures_all_procedures = Procedure_names1 Procedure_names
				   | All_procedures All_procedures
 
data Condition = Combined_conditions Combined_conditions
	       | Combinable_condition Combinable_condition
 
data Combinable_condition = Simple_condition Simple_condition
			  | Negated_simple_conditions Negated_simple_conditions
 
data Simple_condition = Class_condition Class_condition
		      | Relation_condition Relation_condition
		      | Sign_condition Sign_condition
		      | Simple_condition_1 Simple_condition_1
		      | Arithmetic_expression Arithmetic_expression
 
data Simple_condition_1 = Simple_condition_11 Condition
 
data Class_condition = Class_condition1 Identifier Is_or_is_not
					Class_type
 
data Class_type = NUMERIC1
		| ALPHABETIC1
		| ALPHABETIC_LOWER
		| ALPHABETIC_UPPER
		| Class_name Class_name
		| DBCS1
		| KANJI
 
data Relation_condition = Relation_condition1 Arithmetic_expression
					      Relational_operator Simple_condition
 
data Relational_operator = Relational_operator (Maybe ())
					       Relational_operator_tail
 
data Than = THAN
	  | THEN (Maybe ())
 
data Greater = Greater Than
 
data Less = Less Than
 
data Relational_operator_rest = Greater1 Greater
			      | Relational_operator_rest_dunno_c_0
			      | Less1 Less
			      | Relational_operator_rest_dunno_d_0
			      | Equal_to1 Equal_to
 
data Not_relational_operator_rest = Not_relational_operator_rest (Maybe
								    ())
								 Relational_operator_rest
 
data Greater_equal = Greater_equal Than (Maybe ())
 
data Less_equal = Less_equal Than (Maybe ())
 
data Relational_operator_tail = Less_equal_2 Less_equal_2
			      | Relational_operator_tail_dunno_e_0
			      | Not_relational_operator_rest1 Not_relational_operator_rest
			      | Greater_equal1 Greater_equal
			      | Less_equal1 Less_equal
 
data Sign_condition = Sign_condition1 Arithmetic_expression
				      Is_or_is_not Sign_type
 
data Is_or_is_not = Not_is Not_is
		  | Is_not Is_not
 
data Sign_type = POSITIVE
	       | NEGATIVE
	       | ZERO1
	       | ZEROES1
	       | ZEROS1
 
data Combined_conditions = Combined_conditions1 Combinable_condition
						[And_or_combinable_condition]
 
data And_or_combinable_condition = And_or_combinable_condition Alt_and_or
							       (Maybe Relational_operator)
							       Combinable_condition
 
data Negated_simple_conditions = Negated_simple_conditions1 Combinable_condition
 
data Alt_and_or = AND
		| OR
 
data Procedure_name = Procedure_name Paragraph_or_section_name
				     (Maybe In_section_name)
 
data In_section_name = In_section_name In Section_name
 
data Identifier = Identifier_1 Identifier_1
		| Identifier_2 Identifier_2
 
data Identifier_1 = Identifier_11 Qualified_data_name
				  [Subscript_parentheses] (Maybe Reference_modification)
 
data Reference_modification = Reference_modification Leftmost_character_position
						     (Maybe Length)
 
data Identifier_2 = Identifier_21 (Maybe In_file_name)
 
data In_file_name = In_file_name In File_name
 
data Subscript_parentheses = Subscript_parentheses Subscript
 
data Subscript = Subscript [Subscript_expression]
 
data Plus_minus_integer = Plus_minus_integer Alt_plus_minus
					     Integer_number
 
data Subscript_expression_ambiguous = Subscript_expression_ambiguous Qualified_data_name
								     (Maybe Plus_minus_integer)
 
data Subscript_expression = Literal9 Literal
			  | Subscript_expression_ambiguous1 Subscript_expression_ambiguous
 
data Qualified_data_name = Qualified_data_name_1 Qualified_data_name_1
			 | Special_register Special_register
 
data Qualified_data_name_1 = Qualified_data_name_11 Data_name
						    [In_data_or_file_name]
 
data In = IN1
	| OF1
 
data In_data_or_file_name = In_data_or_file_name In
						 Data_or_file_name
 
data Leftmost_character_position = Leftmost_character_position Arithmetic_expression
 
data Length = Length Arithmetic_expression
 
data Arithmetic_expression = Arithmetic_expression1 Times_div
						    [Arithmetic_expression_tail]
 
data Arithmetic_expression_tail = Arithmetic_expression_tail Alt_plus_minus
							     Times_div
 
data Times_div = Times_div Power [Times_div_tail]
 
data Alt_times_div = Alt_times_div_dunno_e_0
		   | Alt_times_div_dunno_f_0
 
data Times_div_tail = Times_div_tail Alt_times_div Power
 
data Power = Power (Maybe Alt_plus_minus) Basis [Power_tail]
 
data Alt_plus_minus = Alt_plus_minus_dunno_g_0
		    | Minus
 
data Power_tail = Power_tail Basis
 
data Basis = Literal10 Literal
	   | Identifier5 Identifier
	   | Basis_1 Basis_1
 
data Basis_1 = Basis_11 Arithmetic_expression
 
data Alphabet_name = Alphabet_name Alphabetic_user_defined_word
 
data Class_name = Class_name1 Alphabetic_user_defined_word
 
data Data_name = Data_name2 Alphabetic_user_defined_word
 
data File_name = File_name1 Alphabetic_user_defined_word
 
data Data_or_file_name = Data_or_file_name Alphabetic_user_defined_word
 
data Index_name = Index_name Alphabetic_user_defined_word
 
data Mnemonic_name = Mnemonic_name Alphabetic_user_defined_word
 
data Record_name = Record_name Qualified_data_name
 
data Symbolic_character = Symbolic_character Alphabetic_user_defined_word
 
data Library_name = Library_name1 User_defined_word
 
data Program_name = Program_name User_defined_word
 
data Text_name = Text_name1 User_defined_word
 
data Paragraph_name = User_defined_word User_defined_word
		    | Integer2 Integer_number
 
data Section_name = User_defined_word1 User_defined_word
		  | Integer3 Integer_number
 
data Paragraph_or_section_name = User_defined_word2 User_defined_word
			       | Integer4 Integer_number
 
data Computer_name = Computer_name System_name
 
data Environment_name = Environment_name System_name
 
data Assignment_name = Assignment_name3 System_name
 
data Figurative_constant = Figurative_constant_simple Figurative_constant_simple
			 | Figurative_constant_all Figurative_constant_all
 
data Figurative_constant_all = Figurative_constant_all1 Literal
 
data Literal = Nonnumeric Nonnumeric
	     | Numeric Numeric
	     | Figurative_constant Figurative_constant
 
data Special_register = Special_register_1 Special_register_1
		      | DEBUG_ITEM
		      | Special_register_2 Special_register_2
		      | RETURN_CODE
		      | SHIFT_OUT
		      | SHIFT_IN
		      | SORT_CONTROL
		      | SORT_CORE_SIZE
		      | SORT_FILE_SIZE
		      | SORT_MESSAGE
		      | SORT_MODE_SIZE
		      | SORT_RETURN
		      | TALLY
		      | WHEN_COMPILED
 
data Special_register_1 = Special_register_11 Data_name
 
data Special_register_2 = Special_register_21 Identifier
 
data Records = RECORD2
	     | RECORDS1
 
data Values = VALUE
	    | VALUES
 
data For_removal = For_removal1 (Maybe ())
 
data No_rewind = No_rewind1
 
data Go_to_statement_3 = Go_to_statement_31 (Maybe ())
 
data Equal_to_1 = Equal_to_11 (Maybe ())
 
data Next_sentence = Next_sentence
 
data Alt_up_down = UP
		 | DOWN
 
data Greater_than_1 = Greater_than_1 (Maybe ())
 
data Greater_than = Greater_than_11 Greater_than_1
		  | Greater_than_dunno_h_0
 
data Greater_than_or_equal_to_1 = Greater_than_or_equal_to_1 (Maybe
								())
							     (Maybe ())
 
data Greater_than_or_equal_to_2 = Greater_than_or_equal_to_2 (Maybe
								())
 
data Greater_than_or_equal_to_3 = Greater_than_or_equal_to_3
 
data Greater_than_or_equal_to = Greater_than_or_equal_to_11 Greater_than_or_equal_to_1
			      | Greater_than_or_equal_to_21 Greater_than_or_equal_to_2
			      | Greater_than_or_equal_to_31 Greater_than_or_equal_to_3
			      | Greater_than_or_equal_to_dunno_i_0
 
data All_procedures = All_procedures1
 
data Is_not = Is_not1 (Maybe ()) (Maybe ())
 
data Not_is = Not_is1
 
data Less_equal_2 = Less_equal_21
 
data Alt_indexed_relative_sequential = INDEXED
				     | RELATIVE
				     | SEQUENTIAL1
 
data Fce_access_mode = Fce_access_mode (Maybe ()) (Maybe ())
				       Alt_sequential_random_dynamic (Maybe Relative_key_clause)
 
data Fce_organization = Fce_organization (Maybe Organization_is)
					 Alt_indexed_relative_sequential
 
data Fce_phrase = Reserve_clause1 Reserve_clause
		| Fce_organization1 Fce_organization
		| Fce_access_mode1 Fce_access_mode
		| Record_key_clause1 Record_key_clause
		| Password_clause1 Password_clause
		| Alternate_record_key_clause1 Alternate_record_key_clause
		| File_status_clause1 File_status_clause
		| Padding_character_clause1 Padding_character_clause
		| Record_delimiter_clause1 Record_delimiter_clause
 
data Set_oper = TO
	      | Alt_up_down_by1 Alt_up_down_by
 
data Set_src = Identifier6 Identifier
	     | Literal11 Literal
	     | TRUE2
	     | ON
	     | OFF
 
data Set_statement_phrase = Set_statement_phrase [Identifier]
						 Set_oper Set_src
 
data Figurative_constant_simple = ZERO2
				| ZEROS2
				| ZEROES2
				| SPACE
				| SPACES
				| HIGH_VALUE
				| HIGH_VALUES
				| LOW_VALUE
				| LOW_VALUES
				| QUOTE
				| QUOTES
				| NULL
				| NULLS
 
data Inspect_by_argument = Identifier7 Identifier
			 | Nonnumeric1 Nonnumeric
			 | Figurative_constant_simple1 Figurative_constant_simple
 
data To_cobword_lit = To_cobword_lit Cobword_lit
 
data Alphabetic_user_defined_word = Alphabetic_user_defined_word Cobword
 
data System_name = System_name Cobword
 
data User_defined_word = User_defined_word3 Cobword
 
data Integer_number = Integer5 Lex_Num
 
data Level_number = Level_number Lex_Num
 
data Priority_number = Priority_number Lex_Num
 
data Numeric = Numeric1 Lex_Num
 
data Number_times = Number_times Cobword_int
 
data On_exception_branch = On_exception_branch (Maybe ())
 
data Not_on_exception_branch = Not_on_exception_branch (Maybe ())
 
data On_size_error_branch = On_size_error_branch (Maybe ())
 
data Not_on_size_error_branch = Not_on_size_error_branch (Maybe ())
 
data Invalid_key_branch = Invalid_key_branch (Maybe ())
 
data Not_invalid_key_branch = Not_invalid_key_branch (Maybe ())
 
data At_end_branch = At_end_branch (Maybe ())
 
data Not_at_end_branch = Not_at_end_branch (Maybe ())
 
data When_branch = When_branch Evaluate_phrase
			       [When_phrase_also_phrase]
 
data When_other_branch = When_other_branch
 
data On_overflow_branch = On_overflow_branch (Maybe ())
 
data Not_on_overflow_branch = Not_on_overflow_branch (Maybe ())
 
data At_eop_branch = At_eop_branch (Maybe ()) End_of_page
 
data Not_at_eop_branch = Not_at_eop_branch (Maybe ()) End_of_page
 
data Else_branch = Else_branch
 
data Primitive = Accept_statement Accept_statement
	       | Add_statement Add_statement
	       | Alter_statement1 Alter_statement
	       | Call_statement1 Call_statement
	       | Cancel_statement1 Cancel_statement
	       | Close_statement1 Close_statement
	       | Compute_statement1 Compute_statement
	       | Continue_statement1 Continue_statement
	       | Delete_statement1 Delete_statement
	       | Display_statement1 Display_statement
	       | Divide_statement Divide_statement
	       | Entry_statement1 Entry_statement
	       | Evaluate_statement1 Evaluate_statement
	       | Exit_program_statement1 Exit_program_statement
	       | Exit_statement1 Exit_statement
	       | Goback_statement1 Goback_statement
	       | Go_to_statement Go_to_statement
	       | If_statement1 If_statement
	       | Initialize_statement1 Initialize_statement
	       | Inspect_statement Inspect_statement
	       | Merge_statement1 Merge_statement
	       | Move_statement Move_statement
	       | Multiply_statement Multiply_statement
	       | Open_statement1 Open_statement
	       | Perform_statement1 Perform_statement
	       | Read_statement1 Read_statement
	       | Release_statement1 Release_statement
	       | Return_statement1 Return_statement
	       | Rewrite_statement1 Rewrite_statement
	       | Search_statement Search_statement
	       | Set_statement1 Set_statement
	       | Sort_statement1 Sort_statement
	       | Start_statement1 Start_statement
	       | Stop_statement1 Stop_statement
	       | String_statement1 String_statement
	       | Subtract_statement Subtract_statement
	       | Unstring_statement1 Unstring_statement
	       | Write_statement1 Write_statement
	       | Copy_statement2 Copy_statement
	       | Use_statement Use_statement
	       | Next_sentence1 Next_sentence
 
data Branch = On_exception_branch1 On_exception_branch
	    | Not_on_exception_branch1 Not_on_exception_branch
	    | On_size_error_branch1 On_size_error_branch
	    | Not_on_size_error_branch1 Not_on_size_error_branch
	    | Invalid_key_branch1 Invalid_key_branch
	    | Not_invalid_key_branch1 Not_invalid_key_branch
	    | At_end_branch1 At_end_branch
	    | Not_at_end_branch1 Not_at_end_branch
	    | When_branch1 When_branch
	    | When_other_branch1 When_other_branch
	    | On_overflow_branch1 On_overflow_branch
	    | Not_on_overflow_branch1 Not_on_overflow_branch
	    | At_eop_branch1 At_eop_branch
	    | Not_at_eop_branch1 Not_at_eop_branch
	    | Else_branch1 Else_branch
 
data Terminator = END_ADD
		| END_CALL
		| END_COMPUTE
		| END_DELETE
		| END_DIVIDE
		| END_EVALUATE
		| END_IF
		| END_MULTIPLY
		| END_PERFORM
		| END_READ
		| END_RETURN
		| END_REWRITE
		| END_SEARCH
		| END_START
		| END_STRING
		| END_SUBTRACT
		| END_UNSTRING
		| END_WRITE
 
type Picture_string = String
 
type Quoted_pseudo_text = String
 
type Nonnumeric = String
 
type Lex_id = String
 
type Lex_Num = String